// ratnum.cpp
// 02/08/2002, Faan Tone Liu
// Implementation of class Ratnum

#include <iostream>
#include "ratnum.h"
using std::cerr;
using std::endl;
using std::cout;

Ratnum::Ratnum()
{
	set_ratnum(0,1);
}

Ratnum::Ratnum(int n)
{
	set_ratnum(n,1);
}

Ratnum::Ratnum(int n, int d)
{
	set_ratnum(n, d);
}

unsigned int Ratnum::get_denominator()
{
	return denominator;
}

int Ratnum::get_numerator()
{
	return numerator;
}

void Ratnum::set_ratnum(int n, int d)
{
	int divisor;
	if (d==0) {
		cerr << "Ratnum: denominator set to 0 - fatal error" << endl;
		exit(1);
	}
	if (n==0) { numerator = 0; denominator =1; return; }
	if (d < 0) {n=-n; d=-d;}
	divisor = gcd(n, d);
	numerator = n/divisor;
	denominator = d/divisor;
}

void Ratnum::display()
{
	cout << numerator << "/" << denominator << endl;
}

double Ratnum::convert_to_double()
{
	return static_cast <double> (numerator) / denominator;
}

// Although this algorithm for gcd works, it is an embarrassingly
// poor performer!  A much more efficient algorithm, and the one
// most commonly used is the "Euclidean algorithm", ancient, yes, but
// still the best!
int Ratnum::gcd(int a, int b)
{
	int test(1), ans(1);
	if (a<0) a = -a;
	if (b < 0) b = -b;
	while (test <= a && test <= b) {
		if (!(a%test) && !(b%test))
			ans = test;
		test++;
	}
	return ans;
}
